/*
 * Projet L2.1 Programmation
 * "Gestion du trafic arien d'un aroport"
 * Daniel Borges & Daniel Dinca
 */

#include "../include/aeroport.h"

/*** evenement_utilisateur
 * Appelle la fonction correspondante  l'action choisie
 */
bool evenement_utilisateur(Option bouton, Liste_compagnie * comp,
	Liste_avions * atte, Liste_avions * decol, Historique * histo, 
	Queue * queue, Liste_noire * noire, int t)
{
    switch(bouton) {
	case NERIENFAIRE:
	    break;
	case AJOUT:
	    puts("\e[0;31m>> Ajouter un avion\e[0m");
	    demande_avion(comp,decol,atte,*noire,t);
	    break;
	case CHARGER:
	    puts("\e[0;31m>> Charger un fichier\e[0m");
	    charger_fichier(comp,decol,atte,*noire,t,NULL);
	    break;
	case SUPPRIMER:
	    puts("\e[0;31m>> Supprimer avion au dcollage\e[0m");
	    supprimer(decol,queue);
	    break;
	case URGENCE:
	    puts("\e[0;31m>> Mettre un avion en urgence\e[0m");
	    mettre_en_urgence(*atte);
	    break;
	case AJOUTCOMPAGNIE:
	    puts("\e[0;31m>> Ajouter une compagnie\e[0m");
	    demande_compagnie(comp,NULL);
	    break;
	case LISTENOIRE:
	    puts("\e[0;31m>> Mettre une compagnie sur liste noire\e[0m");
	    liste_noire(*comp,decol,*atte,noire);
	    break;
	case ALEATOIRE:
	    puts("\e[0;31m>> vnement alatoire\e[0m");
	    evenement_aleatoire(comp,atte,decol,histo,queue,noire,t);
	    break;
	case STATUS:
	    puts("\e[0;31m>> Status\e[0m");
	    status(*comp,*noire,t);
	    break;
	case HISTORIQUE:
	    puts("\e[0;31m>> Historique\e[0m");
	    if ( histo == NULL )
		puts("Historique vide");
	    else
		lire_historique(histo);
	    break;
	case QUITTER:
	    return FAUX;
    }

    return VRAI;
}

/*** evenement_aleatoire
 * Choisit un vnement utilisateur alatoirement
 */
void evenement_aleatoire(Liste_compagnie * comp, Liste_avions * atte,
	Liste_avions * decol, Historique * histo, Queue * queue, 
	Liste_noire * noire, int t)
{
    int action = aleatoire(1,6);
    int taille = 0, carburant, conso, vol;
    char *lecture = NULL, id[7], *heure;
    Liste_compagnie compagnie;

    switch(action) {
	case 1:
	    /* Ajouter un avion au dcollage */
	    puts("Ajout d'un avion au dcollage");

	    /* Compagnie */
	    puts("Compagnie ? ( acronyme )");
	    getline(&lecture,&taille,stdin);
	    while ( ! acronyme_valide(lecture) 
		    || (compagnie = comp_connue(*comp,lecture)) == NULL ) {
		puts("Acronyme invalide ou compagnie inconnue.");
		puts("Veuillez l'entrer  nouveau");
		getline(&lecture,&taille,stdin);
	    }

	    if ( sur_liste_noire(*noire,&(compagnie->comp)) ) {
		puts("Cette compagnie est sur liste noire !");
		free(lecture);
		return;
	    }

	    /* Identifiant */
	    vol = vollibre(compagnie->comp.avions_compagnie);
	    if ( vol == -1 ) {
		puts("Compagnie pleine, impossible d'ajouter un avion");
		break;
	    }
	    sprintf(id,"%c%c%c%03d",lecture[0],lecture[1],lecture[2],vol);
	    
	    /* On rutilise la variable action qui n'est plus utilise
	     * pour gnrer l'heure de dcollage alatoirement */
	    do { action = aleatoire(0,1439);
	    } while ( action >= t && action <= t+DELAI );
	    heure = affichage_heure(action);

	    /* Ajout */
	    alloue_avion(&(compagnie->comp.avions_compagnie),id,0,0,
		    heure,&(compagnie->comp));	    

	    free(heure);
	    break;
	case 2:
	    /* Ajouter un avion  l'attrissage */
	    puts("Ajouter d'un avion  l'attrissage");

	    /* Compagnie */
	    puts("Compagnie ? ( acronyme )");
	    getline(&lecture,&taille,stdin);
	    while ( ! acronyme_valide(lecture) 
		    || (compagnie = comp_connue(*comp,lecture)) == NULL ) {
		puts("Acronyme invalide ou compagnie inconnue.");
		puts("Veuillez l'entrer  nouveau");
		getline(&lecture,&taille,stdin);
	    }

	    if ( sur_liste_noire(*noire,&(compagnie->comp)) ) {
		puts("Cette compagnie est sur liste noire !");
		free(lecture);
		return;
	    }

	    /* Identifiant */
	    vol = vollibre(compagnie->comp.avions_compagnie);
	    if ( vol == -1 ) {
		puts("Compagnie pleine, impossible d'ajouter un avion");
		break;
	    }
	    sprintf(id,"%c%c%c%03d",lecture[0],lecture[1],lecture[2],vol);

	    carburant = aleatoire(5,99);
	    conso = aleatoire(1,carburant%5+1);

	    /* Ajout */
	    alloue_avion(&(compagnie->comp.avions_compagnie),id,carburant,
		    conso,NULL,&(compagnie->comp));
	    break;
	case 3:
	    /* Supprimer un avion au dcollage */
	    puts("Supprimer un avion");
	    supprimer(decol,queue);
	    break;
	case 4:
	    /* Mettre un avion en urgence */
	    puts("Mettre un avion en urgence");
	    mettre_en_urgence(*atte);
	    break;
	case 5:
	    /* Ajouter une compagnie */
	    puts("Ajouter une compagnie");
	    demande_compagnie(comp,NULL);
	    break;
	case 6:
	    /* Mettre une compagnie sur liste noire */
	    puts("Mettre une compagnie sur liste noire");
	    liste_noire(*comp,decol,*atte,noire);
	    break;
    }

    if ( lecture != NULL )
	free(lecture);
}

/*** options
 * Applique les options passes  la ligne de commande
 */
bool options(Liste_compagnie * comp, int * nombre_pistes, Liste_avions *deco,
	Liste_avions *atte, Liste_noire noire, int *t, int argc, char **argv)
{
    char c, *heure;
    int valeur;

    while ( (c = getopt(argc, argv, "c:a:hn:t:")) != EOF ) {
	switch(c) {
	    case 'a':
		charger_fichier(comp,deco,atte,noire,*t,optarg);
		break;
	    case 'c':
		charger_compagnies(optarg,comp);
		break;
	    case 'h':
		printf("Simulation de gestion d'aroport\n\
Options :\n\
 -a <nom fichier> : charge les avions contenu dans <nom fichier>\n\
 -c <nom fichier> : charge les compagnies contenues dans <nom fichier>\n\
 -h               : affiche cette aide puis quitte\n\
 -n <nombre>      : nombre de pistes de l'aroport\n\
 -t <hh:mm>       : change l'heure de dbut du programme\n");
		return FAUX;
		break;
	    case 'n':
		valeur = atoi(optarg);
		*nombre_pistes = ( valeur > 1 ) ? valeur : 1 ;
		printf("Nombre de pistes : %d\n",*nombre_pistes);
		break;
	    case 't':
		if ( *deco != NULL ) {
		    printf("Des avions ont t ajouts, impossible d'initialise l'heure  %s\n.",optarg);
		    break;
		}
		if ( (heure = malloc(4)) == NULL ) {
		    fprintf(stderr,"Impossible de changer l'heure de dpart\n");
		    continue;
		}
		heure[0] = optarg[0];
		heure[1] = optarg[1];
		heure[2] = optarg[3];
		heure[3] = optarg[4];
		valeur = horaire_minute(heure);
		*t = ( valeur < 1440 ) ? valeur : *t ;
		free(heure);
		heure = minute_horaire(*t);
		printf("Horaire de dpart : %c%c:%c%c\n",heure[0],heure[1],
			heure[2],heure[3]);
		free(heure);
		break;
	}
    }

    return VRAI;
}

/*** main
 * initialisation, lancement de la boucle principale, nettoyage
 */
int main (int argc, char **argv)
{
    int t = 480; /* Temps en minutes, ouverture  8h00 -> 8 * 60 = 480 */
    int nombre_pistes = 1;
    Liste_compagnie comp = NULL;
    Liste_avions atterrissages = NULL;
    Liste_avions decollages = NULL;
    Queue piste;
    Historique * historique = NULL;
    Liste_noire noire = NULL;
    bool service = VRAI;
    MlvStruct ecran;
    FILE *log;

    /* Initialisation */
    piste.premier = piste.dernier = NULL;
    create_window(NULL,ECRAN_LARGEUR,ECRAN_HAUTEUR,&ecran);
    name_window("Simulation du Trafic d'un aroport",&ecran);

    /* On efface le contenu de aeroport.log s'il existe */
    if ( (log = fopen("aeroport.log","r")) != NULL ) {
	fclose(log);
	fopen("aeroport.log","w");
	fclose(log);
    }

    service = options(&comp,&nombre_pistes,&decollages,&atterrissages,noire,
	    &t,argc,argv);

    while ( service ) {
	/* affichage */
	affichage(&ecran,t,decollages,atterrissages,&piste,historique,
		nombre_pistes);

	/* Ralentissement de l'affichage */
	usleep(100000);

	/* vnements */
	if ( !(t % 5) )
	    service = evenement_utilisateur(bouton(&ecran),&comp,
		    &atterrissages,&decollages,historique,&piste,&noire,t);
	evenements(&comp,&atterrissages,&decollages,&piste,t,
		&historique,&noire,nombre_pistes);

	/* au bout de 1440 minutes (24h) on revient  minuit */
	t = ( t > 1440 ) ? 0 : t+1;
    }

    close_window(&ecran);
    liberer_compagnies(&comp);
    effacer_historique(&historique);
    effacer_liste_noire(&noire);
    free(noire);

    return 0;
}
